<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8" errorPage="error.jsp"%>
<%@include file="inc/import_package.jsp"%>
<%@include file="inc/getsysteminfo.jsp"%>
<%
    String strErrorFrom = "timeline.jsp";
    SearchData searchData = null;
    WASResultSet wasRS = null;
    String channelID, timeline, timecol, currentDate;
    int classnum;

    String year = "";
    String month = "";
    String day = "";
    String[] date;
    String[][] data;
    int showtype; // 1：显示年轴，2：显示月轴，4：显示日轴，8：柱状图表示，16：横轴表示
    boolean isRegExp;
    ChannelNode node = null;

    StringBuilder html;
    try
    {
        //获取检索结果集
        searchData = WASTools.getSearchDataFromRequest(request);
        channelID = WASTools.getChannelID(loginConfig, searchData, "");
        searchData.setIgnoreTimeLine(true);
        
        node = (ChannelNode) wasConfig.getMapChannel().getNode(Integer.parseInt(channelID)); //频道节点对象
        String field = node.getTimeLineFieldString();
        if (StringUtil.isEmpty(field))
        {
        	out.print("");
        	return;
        }
        
        String custom_expr = "";
        String searchScope = RequestOperation.getStrParameter(request, "searchscope", "");
        String timeScope =  RequestOperation.getStrParameter(request, "timescope", "");
        String timeScopeColumn = RequestOperation.getStrParameter(request, "timescopecolumn", "");
        String orderBy = WASTools.getOrderBy(WASTools.getChannel(wasConfig, channelID), searchData);

        String columnLimit = "";
        if (!StringUtil.isEmpty(searchScope) && !StringUtil.isEmpty(searchData.getAllSearchWord()))
        {
        	columnLimit = searchScope + "=('" + StringUtil.filterForTRSWord(searchData.getAllSearchWord()) + "')";
        }

        if (StringUtil.isEmpty(searchScope) && !StringUtil.isEmpty(searchData.getAllSearchWord()))
        {
        	if (searchData.getAllSearchWord().trim().length() <= 3)
        	{
        		columnLimit = "('" + StringUtil.filterForTRSWord(searchData.getAllSearchWord()) + "')";
        	}
        }

        String timeLimit = "";
        if (!StringUtil.isEmpty(timeScope) && !StringUtil.isEmpty(timeScopeColumn))
        {
        	SimpleDateFormat fmt = new SimpleDateFormat("yyyy.MM.dd"); 
        	
        	java.util.Date d = new java.util.Date();
        	Calendar calendar = Calendar.getInstance();
        	calendar.setTime(d);
        	
        	String nowDate = fmt.format(calendar.getTime());
        	if (timeScope.equals("week"))
        	{
        		calendar.add(Calendar.DATE, -7);
        		timeLimit = fmt.format(calendar.getTime());
        		
        		timeLimit = field + " = between['" + timeLimit + "', '"+ nowDate +"']";
        	}
        	else if (timeScope.equals("month"))
        	{
        		calendar.add(Calendar.MONTH, -1);
        		timeLimit = fmt.format(calendar.getTime());
        		
        		timeLimit = field + " = between['" + timeLimit + "', '"+ nowDate +"']";
        	}
        	else if (timeScope.equals("date"))
        	{
        		timeLimit = field + " = ('" + nowDate + "')";
        	}
        }

        custom_expr = WASTools.buildSQL(columnLimit, timeLimit, "AND");

        //高级检索页面传过来的参数
        String andSen = RequestOperation.getStrParameter(request, "andsen", "");
        String total = RequestOperation.getStrParameter(request, "total", "");
        String orSen = RequestOperation.getStrParameter(request, "orsen", "");
        String exclude = RequestOperation.getStrParameter(request, "exclude", "");
        String adv_expr = StringUtil.buildAdv(total, andSen, orSen, exclude);

        if (!StringUtil.isEmpty(custom_expr))
        {
        	if (StringUtil.isEmpty(columnLimit)) custom_expr = WASTools.buildSQL(searchData.getAllSearchWord(), timeLimit, "AND");
            searchData.setCustomExpr(custom_expr);	//设置后检索以用户自定义的表达式与上频道条件进行检索
        }

        if (!StringUtil.isEmpty(adv_expr))
        {
        	if (!StringUtil.isEmpty(searchScope))
        		adv_expr = searchScope + "=('" + StringUtil.filterForTRSWord(adv_expr) + "')";

        	custom_expr = WASTools.buildSQL(adv_expr, timeLimit, "AND");	
        	
        	if (!StringUtil.isEmpty(custom_expr))
        		searchData.setCustomExpr(custom_expr);
        }

        wasRS = WASTools.getWASResultSet(request, appConfig, wasConfig, loginConfig, searchData, channelID); //was结果集，未进行分类统计

        //对结果集进行分类统计（在设定的日期字段上，以天为单位）
                
        timecol = node.getMapFieldData().getFieldStringByType(WASConstant.COLUMNSPECIALTYPE_TIMELINE); //获取时间字段
        if (timecol == null || timecol.length() == 0) return;
        if (timecol.indexOf(",") > 0) timecol = timecol.substring(0, timecol.indexOf(","));
        isRegExp = true; //是否以正则表达式方式分类
        currentDate = RequestOperation.getStrParameter(request, "timeline", "");
        showtype = RequestOperation.getIntParameter(request, "showtype", 1 | 2 | 16); //显示方式：1-年轴       

        classnum = WASTools.classResultForTimeLine(wasRS, timecol, isRegExp);

        date = currentDate.split("\\.");
        if (date.length > 0)
        {
            year = date[0];
        }	
        if (date.length > 1)
        {
            month = date[0] + "." + date[1];
        }
        if (date.length > 2)
        {
            day = currentDate;
        }

        html = new StringBuilder();
        //判断是否显示年轴
        if ((showtype & 1) == 1)
        {
            data = WASTools.getTimeLine(wasRS, classnum, "", 10, 1, year, 0);
            
            html.append(printTimeLine(data, year, true, showtype)); //年轴
        }
        //判断是否显示月轴
        if (year.length() > 0 && ((showtype & 2) == 2) && year.indexOf("<") < 0)
        {
            data = WASTools.getTimeLine(wasRS, classnum, year, 12, 1, month, 12);
            
            html.append(printTimeLine(data, month, false, showtype)); //月轴
        }
        //判断是否显示日轴
        if (month.length() > 0 && ((showtype & 4) == 4) && month.indexOf("<") < 0)
        {
            data = WASTools.getTimeLine(wasRS, classnum, month, 6, 5, day, 26);
            
            html.append(printTimeLine(data, day, false, showtype)); //日轴
        }

        out.print(html.toString());
    }
    catch (WASException wase)
    {
    	Log4JTool.error(wase);
    }
    catch (Exception e)
    {
    	Log4JTool.error(e);
    }
%>
<%!
	private static String printTimeLine(String[][] data, String currentDate, boolean hasMore, int showType) throws WASException
    {
        if ((showType & 8) == 8)
        {
            return printTimeLine_Histogram(data, currentDate, hasMore); // 柱状图                
        }
        else
        {
            return printTimeLine_Axes(data, currentDate, hasMore); // 横轴
        }
    }

    /**
     * 绘制时间轴（横轴表示）
     * @param data 展示的时间和数据二维数组
     * @param currentDate 当前日期，格式：yyyy.mm.dd
     * @param hasMore 在第一个节点之前是否还有数据
     * @return
     * @throws WASException
     */
    private static String printTimeLine_Axes(String[][] data, String currentDate, boolean hasMore) throws WASException
    {
        if (data == null || currentDate == null) return "";
        // if (showDates.length != recordNums.length) throw new WASException(WASConstant.ERROR_NORMAL + "#绘制时间轴出错#WASTools.printTimeLine#数组长度不符");
        StringBuilder html = new StringBuilder();
        String width = null;
        if (data.length == 12) width = "8.3%";
        else if (data.length == 10) width = "9.9%";
        else
        {
            width = 99 / data.length + "%";
        }
        html.append("<div class=\"TimeLine\"><div class=\"TimeLineBg\"><dl id=\"dl_3\">");
        String display, expr;
        for (int i = 0; i < data.length; i++)
        {
            if (data[i][0] == null || data[i][0].length() == 0) continue;
            int sp = data[i][0].indexOf(",");
            if(sp < 0)
            {
                display = data[i][0];
                expr = data[i][0];
            }
            else
            {
                display = "以前";
                expr = data[i][0].split(",")[1] + data[i][0].split(",")[0];
            }
            html.append("<dd class=" + (currentDate.equals(expr) ? "TimeOn" : "TimeOff") + " style=\"width:" + width + "\" id=\"dd_3_1\" >");
            html.append("<label onclick=\"setTimeLine('" + expr + "')\" ");
            html.append("onmousemove=\"if(this.parentNode.className!='TimeOn'){this.parentNode.className='TimeOnA'}\" ");
            html.append("onmouseout=\"if(this.parentNode.className!='TimeOn'){this.parentNode.className='TimeOff'}\" title=\"" + data[i][1] + "\">");
            html.append("<strong>" + data[i][1] + "篇</strong></label>");
            html.append("<b onclick=\"setTimeLine('" + expr + "')\" title=\"" + display + "\"></b>");
            html.append("<em onclick=\"setTimeLine('" + expr + "')\" title=\"" + data[i][1] + "\" id=\"em_3_1\">" + display);
            //if (hasMore && i == 0) html.append("以前");
            html.append("</em></dd>");
        }
        html.append("</dl></div></div>");

        return html.toString();
    }

    /**
     * 绘制时间轴（柱状图表示）
     * @param data 展示的时间和数据二维数组
     * @param currentDate 当前日期，格式：yyyy.mm.dd
     * @param hasMore 在第一个节点之前是否还有数据
     * @return
     * @throws WASException
     */
    private static String printTimeLine_Histogram(String[][] data, String currentDate, boolean hasMore) throws WASException
    {
        if (data == null || currentDate == null) return "";        
        StringBuilder html = new StringBuilder();
        html.append("<table class=\"TimeLineBody\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\"><tr>");
        String status;
        int max = 0;
        //获取最大值（以最大值为100%，按比例显示）
        for (int i = 0; i < data.length; i++)
        {
            if (max < Integer.parseInt(data[i][1]))
            {
                max = Integer.parseInt(data[i][1]);
            }
        }
        int empty, fill, num;
        String display, expr;
        for (int i = 0; i < data.length; i++)
        {
            if (data[i][0] == null || data[i][0].length() == 0) continue;
            int sp = data[i][0].indexOf(",");
            if(sp < 0)
            {
                display = data[i][0];
                expr = data[i][0];
            }
            else
            {
                display = "以前";
                expr = data[i][0].split(",")[1] + data[i][0].split(",")[0];
            }
            
            num = Integer.parseInt(data[i][1]);
            fill = (num * 98) / max; //填充颜色部分
            if (fill == 0 && (num > 0)) fill += 2; //为使web上能显示出柱状图，只要不为0，至少为2%
            empty = 100 - fill; //空白部分
            status = currentDate.equals(expr) ? "TimeOn" : "TimeOff";
            html.append("<td><table class=\"" + status + "Column\" cellpadding=\"0\" cellspacing=\"0\" border=\"0\" title=\"" + data[i][1] + "篇\" ");
            html.append("onmousemove=\"if(this.className=='TimeOffColumn'){this.className='TimeOverColumn';}if(this.className=='TimeOnColumn'){this.className='TimeOnOverColumn';}\" ");
            html.append("onmouseout=\"if(this.className=='TimeOnOverColumn'){this.className='TimeOnColumn';}if(this.className=='TimeOverColumn'){this.className='TimeOffColumn';}\" ");
            html.append("><tr>");
            html.append("<td class=\"TimeHT\" onclick=\"setTimeLine('" + expr + "')\" ><table cellpadding=\"0\" cellspacing=\"0\" border=\"0\">");
            html.append("<tr height=\"" + empty + "%\"><td class=\"empty\"></td></tr><tr height=\"" + fill + "%\"><td></td></tr>");
            html.append("</table></td></tr><tr><td class=\"TimeFont\">" + display + "");
            //if (hasMore && i == 0) html.append("以前");
            html.append("</td></tr></table></td>");
        }
        html.append("</tr></table>");

        return html.toString();
    }%>